import { jsx as i, jsxs as T, Fragment as D } from "react/jsx-runtime";
import y from "clsx";
import * as c from "react";
import { useRef as A, useReducer as M, useEffect as _, useId as R } from "react";
import { useFloating as x, useClick as S, useDismiss as $, useRole as F, useInteractions as O, useMergeRefs as P, FloatingPortal as k, FloatingOverlay as L, FloatingFocusManager as U } from "@floating-ui/react";
const w = "SET_ANNOUNCEMENT", I = "CLEAR_ANNOUNCEMENT", V = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, B = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case w:
      return {
        ...e,
        announcement: n.payload
      };
    case I:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, j = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: I
  }), typeof e == "function" && e();
}, C = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: l,
  dispatch: t
}) => {
  clearTimeout(o.current), e !== null && t({
    type: w,
    payload: e
  }), n && (o.current = setTimeout(
    () => j({
      onAnnouncementClear: l,
      dispatch: t
    }),
    n
  ));
}, q = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: o,
  clearAnnouncementDelay: l,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: r,
  dispatch: a
}) => {
  clearTimeout(n.current), o ? n.current = setTimeout(C, o, {
    children: e,
    clearAnnouncementDelay: l,
    clearAnnouncementTimeoutRef: t,
    onAnnouncementClear: r,
    dispatch: a
  }) : C({
    children: e,
    clearAnnouncementDelay: l,
    clearAnnouncementTimeoutRef: t,
    onAnnouncementClear: r,
    dispatch: a
  });
};
function W({
  children: e,
  className: n,
  politeness: o,
  role: l = null,
  announcementDelay: t,
  clearAnnouncementDelay: r,
  onAnnouncementClear: a,
  visible: s,
  ...p
}) {
  const u = A(null), d = A(null), [m, f] = M(B, {
    announcement: null
  });
  let h = o;
  typeof h > "u" && (h = l ? V[l] : "assertive"), _(() => {
    q({
      announcementTimeoutRef: u,
      announcementDelay: t,
      children: e,
      clearAnnouncementDelay: r,
      clearAnnouncementTimeoutRef: d,
      onAnnouncementClear: a,
      dispatch: f
    });
  }, [
    e,
    t,
    r,
    a
  ]);
  const g = y(n, {
    "sr-only": !s
  });
  return /* @__PURE__ */ i(
    "div",
    {
      "aria-live": h,
      ...l && { role: l },
      className: g,
      ...p,
      children: m.announcement
    }
  );
}
const E = c.createContext(null);
function H({
  initialOpen: e = !1,
  open: n,
  onOpenChange: o
} = {}) {
  const [l, t] = c.useState(e), [r, a] = c.useState(), [s, p] = c.useState(), u = n ?? l, d = o ?? t, m = x({
    open: u,
    onOpenChange: d
  }), f = m.context, h = S(f, {
    enabled: n == null
  }), g = $(f, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), N = F(f), b = O([h, g, N]);
  return c.useMemo(
    () => ({
      open: u,
      setOpen: d,
      ...b,
      ...m,
      labelId: r,
      descriptionId: s,
      setLabelId: a,
      setDescriptionId: p
    }),
    [u, d, b, m, r, s]
  );
}
const v = () => {
  const e = c.useContext(E);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function X({
  children: e,
  ...n
}) {
  const o = H(n);
  return /* @__PURE__ */ i(E.Provider, { value: o, children: e });
}
const Y = c.forwardRef(function(e, n) {
  const { context: o, ...l } = v(), t = P([l.refs.setFloating, n]);
  if (!o.open)
    return null;
  const { overlayBackground: r, ...a } = e, s = y("grid place-items-center", {
    [`${r}`]: r,
    "bg-black sm:bg-black/[.8]": !r
  });
  return /* @__PURE__ */ i(k, { children: /* @__PURE__ */ i(L, { className: s, lockScroll: !0, children: /* @__PURE__ */ i(U, { context: o, children: /* @__PURE__ */ i(
    "div",
    {
      ref: t,
      "aria-labelledby": l.labelId,
      "aria-describedby": l.descriptionId,
      ...l.getFloatingProps(a),
      children: a.children
    }
  ) }) }) });
}), Z = c.forwardRef(function({ children: e, ...n }, o) {
  const { setLabelId: l } = v(), t = R();
  return c.useLayoutEffect(() => (l(t), () => l(void 0)), [t, l]), /* @__PURE__ */ i("h1", { ...n, ref: o, id: t, children: e });
}), ee = c.forwardRef(function({ children: e, ...n }, o) {
  const { setDescriptionId: l } = v(), t = R();
  return c.useLayoutEffect(() => (l(t), () => l(void 0)), [t, l]), /* @__PURE__ */ i("div", { ...n, ref: o, id: t, children: e });
}), ne = c.forwardRef(function(e, n) {
  const { setOpen: o } = v(), { trigger: l, className: t, ...r } = e, a = c.useCallback(() => o(!1), [o]);
  return /* @__PURE__ */ i("div", { className: t, children: c.cloneElement(l, {
    ref: n,
    onClick: a,
    ...r
  }) });
}), z = (e) => {
  let n = "";
  if (typeof e == "number" || typeof e == "string")
    n = "m-" + e;
  else {
    const o = [];
    (e == null ? void 0 : e.t) !== void 0 && o.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && o.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && o.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && o.push(`ml-${e.l}`), n = o.join(" ");
  }
  return n;
}, oe = ({
  children: e,
  fill: n,
  viewBox: o,
  className: l,
  defaultViewBox: t,
  defaultClassName: r,
  spacing: a,
  title: s,
  semantic: p = !1,
  ...u
}) => {
  const d = z(a), m = y(
    d,
    l || r
  );
  return /* @__PURE__ */ T(D, { children: [
    /* @__PURE__ */ i(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: o || t,
        fill: n || "currentColor",
        role: "img",
        "aria-hidden": !p,
        focusable: !1,
        ...u,
        children: e
      }
    ),
    s && p && /* @__PURE__ */ i("span", { className: "sr-only", children: s })
  ] });
};
/*!
  @versini/ui-private v1.5.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.5.0",
    buildTime: "12/18/2024 12:34 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  W as LiveRegion,
  X as Modal,
  ne as ModalClose,
  Y as ModalContent,
  ee as ModalDescription,
  Z as ModalHeading,
  oe as SvgIcon
};
